library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

entity vga_640 is port(
	clk_vga: in std_logic;
	horizontal_counter : out std_logic_vector (9 downto 0);
	vertical_counter   : out std_logic_vector (9 downto 0);
    hs_out   : out std_logic;
    vs_out   : out std_logic);
end vga_640;

architecture Behavioral of vga_640 is

signal hc: integer range 0 to 799:=0; -- whole-line
signal vc: integer range 0 to 524:=0; -- whole-frame

begin
horizontal_counter <= std_logic_vector(to_unsigned(hc,10));
vertical_counter <= std_logic_vector(to_unsigned(vc,10));
--Bild begint bei Sync-pulse
process
begin
	wait until rising_edge(clk_vga);
	if hc > 0 and hc < 96 then -- 96 = Sync-pulsethen
		hs_out <= '0';
    else
		hs_out <= '1';
    end if;
    if vc > 0 and vc < 2 then -- 2 = Sync-pulse
		vs_out <= '0';
    else
		vs_out <= '1';
    end if;
		hc <= hc + 1;
    if (hc = 799) then --799 = Whole-line
		vc <= vc + 1;
		hc <= 0;
    end if;
    if vc = 524 then --524 = Whole-frame    
		vc <= 0;
    end if;
end process;

end Behavioral;


